"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.Puck = void 0;
var device_controller_1 = require("./device-controller");
var funcToString_1 = require("./helpers/funcToString");
var puck_types_1 = require("./types/puck-types");
var Puck = /** @class */ (function (_super) {
    __extends(Puck, _super);
    function Puck() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.LED = {
            on: function (color) {
                Array.isArray(color)
                    ? _this.UART.write("digitalWrite(".concat(color, ", 1)"))
                    : _this.UART.write("LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ".set();\n"));
            },
            off: function (color) {
                Array.isArray(color)
                    ? _this.UART.write("digitalWrite(".concat(color, ", 0)"))
                    : _this.UART.write("LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ".reset();\n"));
            },
            toggle: function (color) {
                // Add multi light as option
                _this.UART.eval("digitalRead(LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ");\n"), function (val) {
                    val === '0' && _this.LED.on(color);
                });
            },
            flash: function (color, ms) {
                _this.UART.write("digitalPulse(LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ",1,").concat(ms, ");\n"));
            },
            /**
             * digitalWrite([LED3,LED2,LED1], 7)
             * THIS CONTROLS MULTIPLE LEDS AT ONCE, CONSIDER THIS.
             */
        };
        return _this;
    }
    Puck.prototype.onPress = function (func) {
        this.UART.write("\n    setWatch(function(){\n      ".concat((0, funcToString_1.stringifyFunction)(func), ";\n    }, BTN,{edge:\"rising\", repeat:true, debounce:50})\n  "));
    };
    return Puck;
}(device_controller_1.DeviceController));
exports.Puck = Puck;
